From ced6622eabfcf04a5a712c07c0ba8286005fcaca Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Fri, 10 Apr 2020 09:06:17 +0300
Subject: [PATCH 17/59] AlpineApkUpdater: refactor out helper error handler
 func

---
 .../AlpineApkBackend/AlpineApkUpdater.cpp     | 37 +++++++++----------
 .../AlpineApkBackend/AlpineApkUpdater.h       |  6 +++
 2 files changed, 24 insertions(+), 19 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
index d0c0482ef..173b7e48c 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
@@ -215,12 +215,11 @@ void AlpineApkUpdater::startCheckForUpdates()
     updateAction.addArgument(QLatin1String("fakeRoot"), db->fakeRoot());
 
     // run updates check with elevated privileges to access
-    // system package manager files
+    //     system package manager files
     KAuth::ExecuteJob *reply = updateAction.execute();
     QObject::connect(reply, &KAuth::ExecuteJob::result,
                      this, &AlpineApkUpdater::handleKAuthUpdateHelperReply);
-    //QObject::connect(reply, &KAuth::ExecuteJob::newData,
-    //                 this, &AlpineApkUpdater::handleKAuthUpdateHelperProgressStep);
+    // qOverload is needed because of conflict with getter named percent()
     QObject::connect(reply, QOverload<KJob *, unsigned long>::of(&KAuth::ExecuteJob::percent),
                      this, &AlpineApkUpdater::handleKAuthUpdateHelperProgress);
 
@@ -236,14 +235,7 @@ void AlpineApkUpdater::handleKAuthUpdateHelperReply(KJob *job)
         qCDebug(LOG_ALPINEAPK) << "KAuth helper update reply received, updatesCount:" << m_updatesCount;
         Q_EMIT updatesCountChanged(m_updatesCount);
     } else {
-        const QString message = replyData.value(QLatin1String("errorString"),
-                                                reply->errorString()).toString();
-        qCDebug(LOG_ALPINEAPK) << "KAuth helper returned error:" << message << reply->error();
-        if (reply->error() == KAuth::ActionReply::Error::AuthorizationDeniedError) {
-            Q_EMIT passiveMessage(i18n("Authorization denied"));
-        } else {
-            Q_EMIT passiveMessage(i18n("Error") + QStringLiteral(":\n") + message);
-        }
+        handleKAuthHelperError(reply, replyData);
     }
 
     // we are not in the state "Fetching updates" now, update UI
@@ -273,17 +265,24 @@ void AlpineApkUpdater::handleKAuthUpgradeHelperReply(KJob *job)
             }
         }
     } else {
-        const QString message = replyData.value(QLatin1String("errorString"),
-                                                reply->errorString()).toString();
-        qCDebug(LOG_ALPINEAPK) << "KAuth helper returned error:" << message << reply->error();
-        if (reply->error() == KAuth::ActionReply::Error::AuthorizationDeniedError) {
-            Q_EMIT passiveMessage(i18n("Authorization denied"));
-        } else {
-            Q_EMIT passiveMessage(i18n("Error") + QStringLiteral(":\n") + message);
-        }
+        handleKAuthHelperError(reply, replyData);
     }
 
     // we are not in the state "Fetching updates" now, update UI
     Q_EMIT checkForUpdatesFinished();
 }
 
+void AlpineApkUpdater::handleKAuthHelperError(
+        KAuth::ExecuteJob *reply,
+        const QVariantMap &replyData)
+{
+    const QString message = replyData.value(QLatin1String("errorString"),
+                                            reply->errorString()).toString();
+    qCDebug(LOG_ALPINEAPK) << "KAuth helper returned error:" << message << reply->error();
+    if (reply->error() == KAuth::ActionReply::Error::AuthorizationDeniedError) {
+        Q_EMIT passiveMessage(i18n("Authorization denied"));
+    } else {
+        Q_EMIT passiveMessage(i18n("Error") + QStringLiteral(":\n") + message);
+    }
+}
+
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
index 504e8c591..77140ca25 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
@@ -36,6 +36,9 @@
 class AbstractResourcesBackend;
 class AlpineApkBackend;
 class KJob;
+namespace KAuth {
+    class ExecuteJob;
+}
 
 class AlpineApkUpdater : public AbstractBackendUpdater
 {
@@ -164,6 +167,9 @@ public:
     QVector<QtApk::ChangesetItem> &changes() { return m_upgradeable.changes(); }
     const QVector<QtApk::ChangesetItem> &changes() const { return m_upgradeable.changes(); }
 
+protected:
+    void handleKAuthHelperError(KAuth::ExecuteJob *reply, const QVariantMap &replyData);
+
 private:
     AlpineApkBackend *const m_backend;
     int m_updatesCount = 0;
-- 
GitLab


